/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

static int count = 0;

/* Prepare Callback Function */
static void ButtonCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    count++;  /* Count the pressed number */
    printf("Pressed count: %d\n", count);
    if (count >= 5) /* Delete this func when pressed 5 times */
        XtRemoveCallback(w, XmNactivateCallback, ButtonCB, NULL);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, button;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Callback", NULL, 0,
                               &argc, argv, NULL, al, ac);
    ac = 0;
    button = XmCreatePushButton(toplevel, "button", al, ac);
    XtManageChild(button);

    /* Register one callback function */
    XtAddCallback(button, XmNactivateCallback, ButtonCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
